# wxTreeEvent Class Reference
[Events]

`#include <wx/treectrl.h>`

Inheritance diagram for wxTreeEvent:
[legend]

## Detailed Description

A tree event holds information about events associated with wxTreeCtrl objects.

To process input from a tree control, use these event handler macros to direct input to member functions that take a wxTreeEvent argument.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTreeEvent& event)
Event macros:

- EVT_TREE_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button. If you want to enable left-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Also notice that the control must have an associated image list (see SetImageList()) to drag its items under MSW.
- EVT_TREE_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button. If you want to enable right-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default.
- EVT_TREE_END_DRAG(id, func):
  End dragging with the left or right mouse button.
- EVT_TREE_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto().
- EVT_TREE_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto().
- EVT_TREE_DELETE_ITEM(id, func):
  Delete an item.
- EVT_TREE_GET_INFO(id, func):
  Request information from the application.
- EVT_TREE_SET_INFO(id, func):
  Information is being supplied.
- EVT_TREE_ITEM_ACTIVATED(id, func):
  The item has been activated, i.e. chosen by double clicking it with mouse or from keyboard.
- EVT_TREE_ITEM_COLLAPSED(id, func):
  The item has been collapsed.
- EVT_TREE_ITEM_COLLAPSING(id, func):
  The item is being collapsed. This can be prevented by calling Veto().
- EVT_TREE_ITEM_EXPANDED(id, func):
  The item has been expanded.
- EVT_TREE_ITEM_EXPANDING(id, func):
  The item is being expanded. This can be prevented by calling Veto().
- EVT_TREE_ITEM_RIGHT_CLICK(id, func):
  The user has clicked the item with the right mouse button.
- EVT_TREE_ITEM_MIDDLE_CLICK(id, func):
  The user has clicked the item with the middle mouse button.
- EVT_TREE_SEL_CHANGED(id, func):
  Selection has changed.
- EVT_TREE_SEL_CHANGING(id, func):
  Selection is changing. This can be prevented by calling Veto().
- EVT_TREE_KEY_DOWN(id, func):
  A key has been pressed.
- EVT_TREE_ITEM_GETTOOLTIP(id, func):
  The opportunity to set the item tooltip is being given to the application (call SetToolTip()). Windows only.
- EVT_TREE_ITEM_MENU(id, func):
  The context menu for the selected item has been requested, either by a right click or by using the menu key.
- EVT_TREE_STATE_IMAGE_CLICK(id, func):
  The state image has been clicked.

##

Library: wxBase

Category: Events

See also:
  wxTreeCtrl

## Public Member Functions
| wxTreeEvent (wxEventType commandType, wxTreeCtrl *tree, const wxTreeItemId &item=wxTreeItemId())
| Constructor, used by wxWidgets itself only.
wxTreeItemId | GetItem () const
| Returns the item (valid for all events).
int | GetKeyCode () const
| Returns the key code if the event is a key event.
const wxKeyEvent & | GetKeyEvent () const
| Returns the key event for `EVT_TREE_KEY_DOWN` events.
const wxString & | GetLabel () const
| Returns the label if the event is a begin or end edit label event.
wxTreeItemId | GetOldItem () const
| Returns the old item index (valid for `EVT_TREE_ITEM_CHANGING` and `EVT_TREE_ITEM_CHANGED` events).
wxPoint | GetPoint () const
| Returns the position of the mouse pointer if the event is a drag or menu-context event.
bool | IsEditCancelled () const
| Returns true if the label edit was cancelled.
void | SetToolTip (const wxString &tooltip)
| Set the tooltip for the item (valid for `EVT_TREE_ITEM_GETTOOLTIP` events).

List of all members.

## Constructor & Destructor Documentation

wxTreeEvent::wxTreeEvent | ( | wxEventType | commandType,
|  | wxTreeCtrl * | tree,
|  | const wxTreeItemId & | item = `wxTreeItemId()` |
| ) |  |  |

Constructor, used by wxWidgets itself only.

## Member Function Documentation

wxTreeItemId wxTreeEvent::GetItem | ( |  | ) | const

Returns the item (valid for all events).

int wxTreeEvent::GetKeyCode | ( |  | ) | const

Returns the key code if the event is a key event.

Use GetKeyEvent() to get the values of the modifier keys for this event (i.e. Shift or Ctrl).

const wxKeyEvent& wxTreeEvent::GetKeyEvent | ( |  | ) | const

Returns the key event for `EVT_TREE_KEY_DOWN` events.

const wxString& wxTreeEvent::GetLabel | ( |  | ) | const

Returns the label if the event is a begin or end edit label event.

wxTreeItemId wxTreeEvent::GetOldItem | ( |  | ) | const

Returns the old item index (valid for `EVT_TREE_ITEM_CHANGING` and `EVT_TREE_ITEM_CHANGED` events).

wxPoint wxTreeEvent::GetPoint | ( |  | ) | const

Returns the position of the mouse pointer if the event is a drag or menu-context event.

In both cases the position is in client coordinates - i.e. relative to the wxTreeCtrl window (so that you can pass it directly to e.g. wxWindow::PopupMenu()).

bool wxTreeEvent::IsEditCancelled | ( |  | ) | const

Returns true if the label edit was cancelled.

This should be called from within an `EVT_TREE_END_LABEL_EDIT` handler.

void wxTreeEvent::SetToolTip | ( | const wxString & | tooltip | ) |

Set the tooltip for the item (valid for `EVT_TREE_ITEM_GETTOOLTIP` events).

Windows only.

|  | [ top ]